diff --git a/src/main/java/net/minecraft/client/render/WorldRenderer.java b/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 76eecae66..02eadbb28 100644
--- a/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -1,11 +1,11 @@
 package net.minecraft.client.render;
 
+import static org.lwjgl.opengl.GL11.*;
+
 import java.util.List;
 import java.util.Random;
 
-import net.minecraft.client.render.colorizer.ColorizerGrass;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
 import org.lwjgl.util.glu.GLU;
 
 import net.minecraft.client.Minecraft;
@@ -24,6 +24,7 @@ import net.minecraft.client.render.camera.EntityCameraIsometric;
 import net.minecraft.client.render.camera.EntityCameraSleeping;
 import net.minecraft.client.render.camera.EntityCameraThirdPersonFront;
 import net.minecraft.client.render.camera.EntityCameraThirdPersonRear;
+import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.culling.Frustum;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -50,6 +51,21 @@ public class WorldRenderer
 {
     public static final long nsPerSecond = 1_000_000_000L;
     public final LightmapHelper lightmapHelper;
+    public Minecraft mc;
+    private float farPlaneDistance;
+    public ItemRenderer itemRenderer;
+    public FogManager fogManager;
+    private int rendererUpdateCount;
+    private Entity pointedEntity;
+    private MouseFilter mouseFilterXAxis;
+    private MouseFilter mouseFilterYAxis;
+    private float fovModifier;
+    private float fovModifierLast;
+    private long systemTime;
+    private Random random;
+    private int rainSoundCounter;
+    public boolean zooming = false;
+    private float zoomProgress;
 
     public WorldRenderer(Minecraft minecraft)
     {
@@ -59,29 +75,11 @@ public class WorldRenderer
         pointedEntity = null;
         mouseFilterXAxis = new MouseFilter();
         mouseFilterYAxis = new MouseFilter();
-        mouseFilterDummy1 = new MouseFilter();
-        mouseFilterDummy2 = new MouseFilter();
-        mouseFilterDummy3 = new MouseFilter();
-        mouseFilterDummy4 = new MouseFilter();
-        cameraDistance = 4F;
-        cameraDistanceO = 4F;
-        field_22226_t = 0.0F;
-        field_22225_u = 0.0F;
-        field_22224_v = 0.0F;
-        field_22223_w = 0.0F;
-        field_22222_x = 0.0F;
-        field_22221_y = 0.0F;
-        field_22220_z = 0.0F;
-        field_22230_A = 0.0F;
-        cameraZoom = 1.0D;
-        cameraYaw = 0.0D;
-        cameraPitch = 0.0D;
-        prevFrameTime = System.currentTimeMillis();
+        fovModifier = 0.0F;
+        fovModifierLast = 0.0F;
         systemTime = 0L;
         random = new Random();
         rainSoundCounter = 0;
-        field_1394_b = 0;
-        field_1393_c = 0;
         itemRenderer = new ItemRenderer(minecraft);
         fogManager = new FogManager(mc);
     }
@@ -89,11 +87,7 @@ public class WorldRenderer
     public void updateRenderer()
     {
         updateSpeedFov();
-        cameraDistanceO = cameraDistance;
-        field_22225_u = field_22226_t;
-        field_22223_w = field_22224_v;
-        field_22221_y = field_22222_x;
-        field_22230_A = field_22220_z;
+        fovModifierLast = fovModifier;
         if(mc.activeCamera == null)
         {
             mc.activeCamera = new EntityCameraFirstPerson(mc, mc.thePlayer);
@@ -216,7 +210,7 @@ public class WorldRenderer
             float f2 = (float)entityliving.deathTime + partialTick;
             f1 /= (1.0F - 500F / (f2 + 500F)) * 2.0F + 1.0F;
         }
-        return f1 + field_22221_y + (field_22222_x - field_22221_y) * partialTick;
+        return f1 + fovModifierLast + (fovModifier - fovModifierLast) * partialTick;
     }
 
     private void hurtCameraEffect(float partialTick)
@@ -227,7 +221,7 @@ public class WorldRenderer
         if(entityliving.getHealth() <= 0)
         {
             float f2 = (float)entityliving.deathTime + partialTick;
-            GL11.glRotatef(40F - 8000F / (f2 + 200F), 0.0F, 0.0F, 1.0F);
+            glRotatef(40F - 8000F / (f2 + 200F), 0.0F, 0.0F, 1.0F);
         }
         if(f1 < 0.0F)
         {
@@ -237,9 +231,9 @@ public class WorldRenderer
             f1 /= entityliving.maxHurtTime;
             f1 = MathHelper.sin(f1 * f1 * f1 * f1 * 3.141593F);
             float f3 = entityliving.attackedAtYaw;
-            GL11.glRotatef(-f3, 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(-f1 * 14F, 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(f3, 0.0F, 1.0F, 0.0F);
+            glRotatef(-f3, 0.0F, 1.0F, 0.0F);
+            glRotatef(-f1 * 14F, 0.0F, 0.0F, 1.0F);
+            glRotatef(f3, 0.0F, 1.0F, 0.0F);
             return;
         }
     }
@@ -252,15 +246,13 @@ public class WorldRenderer
             float f1 = entityplayer.walkDist - entityplayer.walkDistO;
             float f2 = -(entityplayer.walkDist + f1 * partialTick);
             float f3 = entityplayer.field_775_e + (entityplayer.field_774_f - entityplayer.field_775_e) * partialTick;
-            float f4 = entityplayer.prevCameraPitch + (entityplayer.cameraPitch - entityplayer.prevCameraPitch) * partialTick;
             if (entityplayer.isSkating)
             {
                 f2 *= 0.25f;
-                f4 *= 0.25f;
             };
-            GL11.glTranslatef(MathHelper.sin(f2 * 3.141593F) * f3 * 0.5F, -java.lang.Math.abs(MathHelper.cos(f2 * 3.141593F) * f3), 0.0F);
-            GL11.glRotatef(MathHelper.sin(f2 * 3.141593F) * f3 * 3F, 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(java.lang.Math.abs(MathHelper.cos(f2 * 3.141593F - 0.2F) * f3) * 5F, 1.0F, 0.0F, 0.0F);
+            glTranslatef(MathHelper.sin(f2 * 3.141593F) * f3 * 0.5F, -java.lang.Math.abs(MathHelper.cos(f2 * 3.141593F) * f3), 0.0F);
+            glRotatef(MathHelper.sin(f2 * 3.141593F) * f3 * 3F, 0.0F, 0.0F, 1.0F);
+            glRotatef(java.lang.Math.abs(MathHelper.cos(f2 * 3.141593F - 0.2F) * f3) * 5F, 1.0F, 0.0F, 0.0F);
         }
     }
 
@@ -306,23 +298,22 @@ public class WorldRenderer
 
         if(!(mc.currentScreen instanceof GuiPhotoMode) && !mc.gameSettings.lockCamera.value)
         {
-            GL11.glRotatef((float) mc.activeCamera.getXRot(partialTick), 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef((float) (mc.activeCamera.getYRot(partialTick) + 180F), 0.0F, 1.0F, 0.0F);
+            glRotatef((float) mc.activeCamera.getXRot(partialTick), 1.0F, 0.0F, 0.0F);
+            glRotatef((float) (mc.activeCamera.getYRot(partialTick) + 180F), 0.0F, 1.0F, 0.0F);
         }
 
         if (mc.currentScreen instanceof GuiPhotoMode)
         {
-            GL11.glRotatef(((GuiPhotoMode)mc.currentScreen).getTilt(partialTick), 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(45f + 45F * ((GuiPhotoMode)mc.currentScreen).getRotation(partialTick), 0.0F, 1.0F, 0.0F);
+            glRotatef(((GuiPhotoMode)mc.currentScreen).getTilt(partialTick), 1.0F, 0.0F, 0.0F);
+            glRotatef(45f + 45F * ((GuiPhotoMode)mc.currentScreen).getRotation(partialTick), 0.0F, 1.0F, 0.0F);
         }
     }
 
     private void setupCameraTransform(float partialTick)
     {
         farPlaneDistance = mc.gameSettings.renderDistance.value.chunks * 16;
-        GL11.glMatrixMode(5889 /*GL_PROJECTION*/);
-        GL11.glLoadIdentity();
-        float f1 = 0.07F;
+        glMatrixMode(GL_PROJECTION);
+        glLoadIdentity();
         float fov = getFOVModifier(partialTick, true);
         if(zooming) {
             fov = getZoomedFOV(fov, partialTick);
@@ -332,21 +323,15 @@ public class WorldRenderer
         if (mc.currentScreen instanceof GuiPhotoMode)
         {
             double div = java.lang.Math.pow(2, ((GuiPhotoMode)mc.currentScreen).getZoom(partialTick));
-            GL11.glTranslatef(1, 1, 0);
-            GL11.glOrtho(0, mc.resolution.width / div, 0, mc.resolution.height / div, farPlaneDistance * -2.0f, farPlaneDistance * 2.0f);
-            GL11.glTranslatef(((GuiPhotoMode)mc.currentScreen).getPanX(partialTick), -((GuiPhotoMode)mc.currentScreen).getPanY(partialTick), 0);
-        }
-        else if(cameraZoom != 1.0D)
-        {
-            GL11.glTranslatef((float)cameraYaw, (float)(-cameraPitch), 0.0F);
-            GL11.glScaled(cameraZoom, cameraZoom, 1.0D);
-            GLU.gluPerspective(fov, (float)mc.resolution.width / (float)mc.resolution.height, 0.05F, farPlaneDistance * 2.0F);
+            glTranslatef(1, 1, 0);
+            glOrtho(0, mc.resolution.width / div, 0, mc.resolution.height / div, farPlaneDistance * -2.0f, farPlaneDistance * 2.0f);
+            glTranslatef(((GuiPhotoMode)mc.currentScreen).getPanX(partialTick), -((GuiPhotoMode)mc.currentScreen).getPanY(partialTick), 0);
         } else
         {
             GLU.gluPerspective(fov, (float)mc.resolution.width / (float)mc.resolution.height, 0.05F, farPlaneDistance * 2.0F);
         }
-        GL11.glMatrixMode(GL11.GL_MODELVIEW);
-        GL11.glLoadIdentity();
+        glMatrixMode(GL_MODELVIEW);
+        glLoadIdentity();
         hurtCameraEffect(partialTick);
         if(mc.gameSettings.viewBobbing.value && !(mc.currentScreen instanceof GuiPhotoMode))
         {
@@ -357,17 +342,17 @@ public class WorldRenderer
         {
             float f3 = 5F / (f2 * f2 + 5F) - f2 * 0.04F;
             f3 *= f3;
-            GL11.glRotatef(((float)rendererUpdateCount + partialTick) * 20F, 0.0F, 1.0F, 1.0F);
-            GL11.glScalef(1.0F / f3, 1.0F, 1.0F);
-            GL11.glRotatef(-((float)rendererUpdateCount + partialTick) * 20F, 0.0F, 1.0F, 1.0F);
+            glRotatef(((float)rendererUpdateCount + partialTick) * 20F, 0.0F, 1.0F, 1.0F);
+            glScalef(1.0F / f3, 1.0F, 1.0F);
+            glRotatef(-((float)rendererUpdateCount + partialTick) * 20F, 0.0F, 1.0F, 1.0F);
         }
         orientCamera(partialTick);
     }
 
-    private void setupPlayerCamera(float partialTick)
+    private void renderHand(float partialTick)
     {
-        GL11.glMatrixMode(5889 /*GL_PROJECTION*/);
-        GL11.glLoadIdentity();
+        glMatrixMode(GL_PROJECTION);
+        glLoadIdentity();
         float fov = getFOVModifier(partialTick, false);
         if(zooming){
             fov = getZoomedFOV(fov, partialTick);
@@ -375,19 +360,14 @@ public class WorldRenderer
             zoomProgress = 0;
         }
         // Fix hand being rendered inside of blocks / behind rain
-        GL11.glTranslatef(0.0f, 0.0f, -1.0f);
-        GL11.glScalef(1.0f, 1.0f, 0.1f);
+        glTranslatef(0.0f, 0.0f, -1.0f);
+        glScalef(1.0f, 1.0f, 0.1f);
         
-        if(cameraZoom != 1.0D)
-        {
-            GL11.glTranslatef((float)cameraYaw, (float)(-cameraPitch), 0.0F);
-            GL11.glScaled(cameraZoom, cameraZoom, 1.0D);
-        }
         GLU.gluPerspective(fov, (float)mc.resolution.width / (float)mc.resolution.height, 0.05F, farPlaneDistance * 2.0F);
-        GL11.glMatrixMode(5888 /*GL_MODELVIEW0_ARB*/);
-        GL11.glLoadIdentity();
+        glMatrixMode(GL_MODELVIEW);
+        glLoadIdentity();
 
-        GL11.glPushMatrix();
+        glPushMatrix();
         hurtCameraEffect(partialTick);
         if(mc.gameSettings.viewBobbing.value)
         {
@@ -399,7 +379,11 @@ public class WorldRenderer
             if(!zooming) itemRenderer.renderItemInFirstPerson(partialTick);
             lightmapHelper.disableLightmapRendering();
         }
-        GL11.glPopMatrix();
+        glPopMatrix();
+        
+        Debug.change("post");
+        mc.renderer.endRenderWorld(partialTick);
+        
         if(mc.gameSettings.thirdPersonView.value == 0 && !(!(mc.activeCamera instanceof EntityCamera) || ((EntityCamera) mc.activeCamera).entity.isPlayerSleeping()))
         {
             itemRenderer.renderOverlays(partialTick);
@@ -513,12 +497,9 @@ public class WorldRenderer
         } else {
             c = mc.gameSettings.customFpsLimit.value;
         }
-        GL11.glViewport(0, 0, mc.resolution.width, mc.resolution.height);
+        glViewport(0, 0, mc.resolution.width, mc.resolution.height);
         if(mc.theWorld != null)
         {
-            Debug.change("post");
-            mc.render.beginRenderWorld(partialTick);
-            
             Debug.change("world");
             if(!mc.gameSettings.enableVsync.value && mc.gameSettings.customFpsLimit.value == 0) // Max FPS
             {
@@ -547,18 +528,16 @@ public class WorldRenderer
                 Debug.change("misc");
             }
             systemTime = System.nanoTime();
-
-            Debug.change("post");
-            mc.render.endRenderWorld(partialTick);
+            
             Debug.change("hud");
             mc.ingameGUI.renderGameOverlay(partialTick, mc.currentScreen != null, mouseX, mouseY);
             Debug.change("misc");
         } else
         {
-            GL11.glMatrixMode(5889 /*GL_PROJECTION*/);
-            GL11.glLoadIdentity();
-            GL11.glMatrixMode(5888 /*GL_MODELVIEW0_ARB*/);
-            GL11.glLoadIdentity();
+            glMatrixMode(GL_PROJECTION);
+            glLoadIdentity();
+            glMatrixMode(GL_MODELVIEW);
+            glLoadIdentity();
             setupScaledResolution();
             if(mc.gameSettings.enableVsync.value || mc.gameSettings.customFpsLimit.value > 0)
             {
@@ -586,7 +565,7 @@ public class WorldRenderer
         if(mc.currentScreen != null)
         {
             Debug.change("gui");
-            GL11.glClear(256);
+            glClear(256);
             if(mc.inputType == InputType.CONTROLLER) {
                 mouseX = (int) mc.controllerInput.cursorX;
                 mouseY = (int) mc.controllerInput.cursorY;
@@ -602,12 +581,13 @@ public class WorldRenderer
     public void renderWorld(float partialTick, long updateRenderersUntil)
     {
     	Debug.push("misc");
+        Colorizers.update(false);
+        
         RenderGlobal renderGlobal = mc.renderGlobal;
         EffectRenderer effectRenderer = mc.effectRenderer;
-        ColorizerGrass.update(false);
-
-        GL11.glEnable(GL11.GL_CULL_FACE);
-        GL11.glEnable(GL11.GL_DEPTH_TEST);
+        
+        glEnable(GL_CULL_FACE);
+        glEnable(GL_DEPTH_TEST);
         if(mc.activeCamera == null)
         {
             mc.activeCamera = new EntityCameraFirstPerson(mc, mc.thePlayer);
@@ -634,25 +614,28 @@ public class WorldRenderer
         }
 
         fogManager.updateFogColor(partialTick);
-        GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);
-        GL11.glEnable(2884 /*GL_CULL_FACE*/);
+        
+        Debug.change("post");
+        mc.renderer.beginRenderWorld(partialTick);
+        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+        glEnable(GL_CULL_FACE);
         setupCameraTransform(partialTick);
         Frustum.getFrustum();
         Debug.change("sky");
         if(mc.gameSettings.renderDistance.value.renderSky && !(mc.currentScreen instanceof GuiModelViewer))
         {
             fogManager.setupFog(FogManager.FOG_MODE_SKY, farPlaneDistance, partialTick);
-            GL11.glDisable(GL11.GL_FOG);
+            glDisable(GL_FOG);
 
             renderGlobal.drawSky(partialTick);
         }
         
         Debug.change("misc");
-        GL11.glEnable(2912 /*GL_FOG*/);
+        glEnable(GL_FOG);
         fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTick);
         if(mc.gameSettings.ambientOcclusion.value)
         {
-            GL11.glShadeModel(7425 /*GL_SMOOTH*/);
+            glShadeModel(7425 /*GL_SMOOTH*/);
         }
         
         mc.renderGlobal.clipRenderersByFrustum(mc.activeCamera.getFrustum(), partialTick);
@@ -675,7 +658,7 @@ public class WorldRenderer
         } while(l1 >= 0L && l1 <= nsPerSecond);
 
         fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTick);
-        GL11.glEnable(2912 /*GL_FOG*/);
+        glEnable(GL_FOG);
         TextureRegistry.blockAtlas.bindTexture();
         Lighting.disable();
 
@@ -684,16 +667,16 @@ public class WorldRenderer
         renderGlobal.sortAndRender(mc.activeCamera, 0, partialTick);
 
         Debug.change("entities");
-        GL11.glShadeModel(7424 /*GL_FLAT*/);
+        glShadeModel(GL_FLAT);
         Lighting.enableLight();
         if (!mc.gameSettings.fog.value)
         {
-            GL11.glDisable(GL11.GL_FOG);
+            glDisable(GL_FOG);
         }
         renderGlobal.renderEntities(mc.activeCamera, partialTick);
         if (!mc.gameSettings.fog.value)
         {
-            GL11.glEnable(GL11.GL_FOG);
+            glEnable(GL_FOG);
         }
         
         Debug.change("particles");
@@ -707,10 +690,10 @@ public class WorldRenderer
         Debug.change("outline");
         if(mc.objectMouseOver != null)
         {
-            GL11.glDisable(GL11.GL_ALPHA_TEST);
+            glDisable(GL_ALPHA_TEST);
             renderGlobal.drawBlockBreaking(mc.activeCamera, mc.objectMouseOver, partialTick);
             renderGlobal.drawSelectionBox(mc.activeCamera, mc.objectMouseOver, partialTick);
-            GL11.glEnable(GL11.GL_ALPHA_TEST);
+            glEnable(GL_ALPHA_TEST);
         }
         
         Debug.change("debugoverlays");
@@ -722,10 +705,10 @@ public class WorldRenderer
         {
         	renderGlobal.drawDebugChunkBorders(mc.activeCamera, partialTick);
         }
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
         fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTick);
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glDisable(GL11.GL_CULL_FACE);
+        glEnable(GL_BLEND);
+        glDisable(GL_CULL_FACE);
         TextureRegistry.blockAtlas.bindTexture();
 
         Debug.change("water");
@@ -733,26 +716,26 @@ public class WorldRenderer
         {
             if(mc.gameSettings.ambientOcclusion.value)
             {
-                GL11.glShadeModel(GL11.GL_SMOOTH);
+                glShadeModel(GL_SMOOTH);
             }
-            GL11.glColorMask(false, false, false, false);
+            glColorMask(false, false, false, false);
             int i1 = renderGlobal.sortAndRender(mc.activeCamera, 1, partialTick);
-            GL11.glColorMask(true, true, true, true);
+            glColorMask(true, true, true, true);
             if(i1 > 0)
             {
                 lightmapHelper.enableLightmapRendering();
                 if (!mc.gameSettings.fog.value)
                 {
-                    GL11.glDisable(GL11.GL_FOG);
+                    glDisable(GL_FOG);
                 }
                 renderGlobal.callAllDisplayLists(1, partialTick);
                 if (!mc.gameSettings.fog.value)
                 {
-                    GL11.glEnable(GL11.GL_FOG);
+                    glEnable(GL_FOG);
                 }
                 lightmapHelper.disableLightmapRendering();
             }
-            GL11.glShadeModel(GL11.GL_FLAT);
+            glShadeModel(GL_FLAT);
         }
         else
         {
@@ -762,27 +745,24 @@ public class WorldRenderer
         }
         
         Debug.change("weather");
-        GL11.glDepthMask(true);
-        GL11.glEnable(GL11.GL_CULL_FACE);
-        GL11.glDisable(GL11.GL_BLEND);
+        glDepthMask(true);
+        glEnable(GL_CULL_FACE);
+        glDisable(GL_BLEND);
         renderRainSnow(partialTick);
-        GL11.glDisable(GL11.GL_FOG);
+        glDisable(GL_FOG);
         if(mc.gameSettings.clouds.value) {
         	Debug.change("clouds");
             fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTick);
-            GL11.glEnable(GL11.GL_FOG);
+            glEnable(GL_FOG);
             renderGlobal.renderClouds(partialTick);
-            GL11.glDisable(GL11.GL_FOG);
+            glDisable(GL_FOG);
         }
 
         Debug.change("misc");
         fogManager.setupFog(1, farPlaneDistance, partialTick);
-        if(cameraZoom == 1.0D)
-        {
-            setupPlayerCamera(partialTick);
-        }
-
-        GL11.glColorMask(true, true, true, true);
+        renderHand(partialTick);
+        
+        glColorMask(true, true, true, true);
         Debug.pop();
     }
 
@@ -872,13 +852,13 @@ public class WorldRenderer
         int posY = MathHelper.floor_double(mc.activeCamera.getY());
         int posZ = MathHelper.floor_double(mc.activeCamera.getZ());
         Tessellator tessellator = Tessellator.instance;
-        GL11.glDisable(2884 /*GL_CULL_FACE*/);
-        GL11.glNormal3f(0.0F, 1.0F, 0.0F);
-        GL11.glEnable(3042 /*GL_BLEND*/);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glAlphaFunc(516, 0.01F);
+        glDisable(2884 /*GL_CULL_FACE*/);
+        glNormal3f(0.0F, 1.0F, 0.0F);
+        glEnable(3042 /*GL_BLEND*/);
+        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+        glAlphaFunc(516, 0.01F);
         
-        GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, mc.renderEngine.getTexture(weather.texturePath));
+        glBindTexture(3553 /*GL_TEXTURE_2D*/, mc.renderEngine.getTexture(weather.texturePath));
         
         double nextPosX = mc.activeCamera.getX(partialTick);
         double nextPosY = mc.activeCamera.getY(partialTick);
@@ -926,7 +906,7 @@ public class WorldRenderer
                         tessellator.startDrawingQuads();
                         float f12 = world.getLightBrightness(x, i3, z);
                         if (mc.fullbright) f12 = 1.0f;
-                        GL11.glColor4f(f12, f12, f12, ((1.0F - f11 * f11) * 0.3F + 0.5F) * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower());
+                        glColor4f(f12, f12, f12, ((1.0F - f11 * f11) * 0.3F + 0.5F) * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower());
                         tessellator.setTranslation(-nextPosX * 1.0D, -nextPosY * 1.0D, -nextPosZ * 1.0D);
                         tessellator.addVertexWithUV(x + 0, k3, (double)z + 0.5D, 0.0F * f3 + f7, ((float)k3 * f3) / 4F + f6 * f3 + f8);
                         tessellator.addVertexWithUV(x + 1, k3, (double)z + 0.5D, 1.0F * f3 + f7, ((float)k3 * f3) / 4F + f6 * f3 + f8);
@@ -973,7 +953,7 @@ public class WorldRenderer
                         tessellator.startDrawingQuads();
                         float f10 = world.getLightBrightness(x, world.getHeightBlocks(), z) * 0.85F + 0.15F;
                         if (mc.fullbright) f10 = 1.0f;
-                        GL11.glColor4f(f10, f10, f10, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.weatherManager.getWeatherIntensity() - 0.1f) * world.weatherManager.getWeatherPower());
+                        glColor4f(f10, f10, f10, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.weatherManager.getWeatherIntensity() - 0.1f) * world.weatherManager.getWeatherPower());
                         tessellator.setTranslation(-nextPosX * 1.0D, -nextPosY * 1.0D, -nextPosZ * 1.0D);
                         tessellator.addVertexWithUV(x + 0, j3, (double)z + 0.5D, 0.0F * f2, ((float)j3 * f2) / 4F + f4 * f2);
                         tessellator.addVertexWithUV(x + 1, j3, (double)z + 0.5D, 1.0F * f2, ((float)j3 * f2) / 4F + f4 * f2);
@@ -1027,7 +1007,7 @@ public class WorldRenderer
                         tessellator.startDrawingQuads();
                         float f10 = world.getLightBrightness(x, world.getHeightBlocks(), z) * 0.85F + 0.15F;
                         if (mc.fullbright) f10 = 1.0f;
-                        GL11.glColor4f(f10, f10, f10, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.weatherManager.getWeatherIntensity() - 0.1f) * world.weatherManager.getWeatherPower());
+                        glColor4f(f10, f10, f10, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.weatherManager.getWeatherIntensity() - 0.1f) * world.weatherManager.getWeatherPower());
                         tessellator.setTranslation(-nextPosX * 1.0D, -nextPosY * 1.0D, -nextPosZ * 1.0D);
                         tessellator.addVertexWithUV(x + 0, j3, (double)z + 0.5D, 0.0F * f2, ((float)j3 * f2) / 4F - vOffset * f2);
                         tessellator.addVertexWithUV(x + 1, j3, (double)z + 0.5D, 1.0F * f2, ((float)j3 * f2) / 4F - vOffset * f2);
@@ -1046,53 +1026,19 @@ public class WorldRenderer
         }
 
 
-        GL11.glEnable(2884 /*GL_CULL_FACE*/);
-        GL11.glDisable(3042 /*GL_BLEND*/);
-        GL11.glAlphaFunc(516, 0.1F);
+        glEnable(2884 /*GL_CULL_FACE*/);
+        glDisable(3042 /*GL_BLEND*/);
+        glAlphaFunc(516, 0.1F);
     }
 
     public void setupScaledResolution()
     {
-        GL11.glClear(256);
-        GL11.glMatrixMode(5889 /*GL_PROJECTION*/);
-        GL11.glLoadIdentity();
-        GL11.glOrtho(0.0D, mc.resolution.scaledWidthExact, mc.resolution.scaledHeightExact, 0.0D, 1000D, 3000D);
-        GL11.glMatrixMode(5888 /*GL_MODELVIEW0_ARB*/);
-        GL11.glLoadIdentity();
-        GL11.glTranslatef(0.0F, 0.0F, -2000F);
+        glClear(256);
+        glMatrixMode(5889 /*GL_PROJECTION*/);
+        glLoadIdentity();
+        glOrtho(0.0D, mc.resolution.scaledWidthExact, mc.resolution.scaledHeightExact, 0.0D, 1000D, 3000D);
+        glMatrixMode(5888 /*GL_MODELVIEW0_ARB*/);
+        glLoadIdentity();
+        glTranslatef(0.0F, 0.0F, -2000F);
     }
-
-    public Minecraft mc;
-    private float farPlaneDistance;
-    public ItemRenderer itemRenderer;
-    public FogManager fogManager;
-    private int rendererUpdateCount;
-    private Entity pointedEntity;
-    private MouseFilter mouseFilterXAxis;
-    private MouseFilter mouseFilterYAxis;
-    private MouseFilter mouseFilterDummy1;
-    private MouseFilter mouseFilterDummy2;
-    private MouseFilter mouseFilterDummy3;
-    private MouseFilter mouseFilterDummy4;
-    private float cameraDistance;
-    private float cameraDistanceO;
-    private float field_22226_t;
-    private float field_22225_u;
-    private float field_22224_v;
-    private float field_22223_w;
-    private float field_22222_x;
-    private float field_22221_y;
-    private float field_22220_z;
-    private float field_22230_A;
-    private double cameraZoom;
-    private double cameraYaw;
-    private double cameraPitch;
-    private long prevFrameTime;
-    private long systemTime;
-    private Random random;
-    private int rainSoundCounter;
-    volatile int field_1394_b;
-    volatile int field_1393_c;
-    public boolean zooming = false;
-    private float zoomProgress;
 }
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorCustom.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorCustom.java
new file mode 100644
index 000000000..a0fcdb374
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorCustom.java
@@ -0,0 +1,28 @@
+package net.minecraft.client.render.block.color;
+
+import net.minecraft.client.render.colorizer.Colorizer;
+import net.minecraft.core.world.WorldSource;
+
+public class BlockColorCustom extends BlockColor {
+
+	public Colorizer colorizer;
+	
+	public BlockColorCustom(Colorizer colorizer) {
+		this.colorizer = colorizer;
+		
+		if(colorizer == null) {
+			throw new NullPointerException();
+		}
+	}
+	
+	@Override
+	public int getFallbackColor(int meta) {
+		return colorizer.getDefaultColor(1.0, 0.7);
+	}
+
+	@Override
+	public int getWorldColor(WorldSource world, int x, int y, int z) {
+		return colorizer.getColor(world, x, y, z);
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
index 1ff86d6e8..5174775ed 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.block.color;
 
+import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.util.dispatch.Dispatcher;
 import net.minecraft.core.block.Block;
 
@@ -16,28 +17,28 @@ public final class BlockColorDispatcher
 
     private BlockColorDispatcher()
     {
-        addDispatch(Block.algae, new BlockColorGrass());
-        addDispatch(Block.fluidWaterStill, new BlockColorWater());
-        addDispatch(Block.fluidWaterFlowing, new BlockColorWater());
-        addDispatch(Block.grass, new BlockColorGrass());
-        addDispatch(Block.layerLeavesOak, new BlockColorLeavesOak());
-        addDispatch(Block.leavesBirch, new BlockColorLeaves("birch"));
-        addDispatch(Block.leavesCherry, new BlockColorLeaves("cherry"));
-        addDispatch(Block.leavesCherryFlowering, new BlockColorLeaves("cherry"));
-        addDispatch(Block.leavesEucalyptus, new BlockColorLeaves("eucalyptus"));
-        addDispatch(Block.leavesCacao, new BlockColorLeaves("cocoa"));
-        addDispatch(Block.leavesOak, new BlockColorLeavesOak());
-        addDispatch(Block.leavesPine, new BlockColorLeaves("pine"));
-        addDispatch(Block.leavesShrub, new BlockColorLeaves("shrub"));
-        addDispatch(Block.leavesThorn, new BlockColorLeaves("caatinga"));
-        addDispatch(Block.leavesPalm, new BlockColorLeaves("palm"));
-        addDispatch(Block.mossStone, new BlockColorGrass());
-        addDispatch(Block.mossBasalt, new BlockColorGrass());
-        addDispatch(Block.mossLimestone, new BlockColorGrass());
-        addDispatch(Block.mossGranite, new BlockColorGrass());
+        addDispatch(Block.algae, new BlockColorCustom(Colorizers.grass));
+        addDispatch(Block.fluidWaterStill, new BlockColorCustom(Colorizers.water));
+        addDispatch(Block.fluidWaterFlowing, new BlockColorCustom(Colorizers.water));
+        addDispatch(Block.grass, new BlockColorCustom(Colorizers.grass));
+        addDispatch(Block.layerLeavesOak, new BlockColorLeavesOak(Colorizers.oak));
+        addDispatch(Block.leavesBirch, new BlockColorCustom(Colorizers.birch));
+        addDispatch(Block.leavesCherry, new BlockColorCustom(Colorizers.cherry));
+        addDispatch(Block.leavesCherryFlowering, new BlockColorCustom(Colorizers.cherry));
+        addDispatch(Block.leavesEucalyptus, new BlockColorCustom(Colorizers.eucalyptus));
+        addDispatch(Block.leavesCacao, new BlockColorCustom(Colorizers.cacao));
+        addDispatch(Block.leavesOak, new BlockColorLeavesOak(Colorizers.oak));
+        addDispatch(Block.leavesPine, new BlockColorCustom(Colorizers.pine));
+        addDispatch(Block.leavesShrub, new BlockColorCustom(Colorizers.shrub));
+        addDispatch(Block.leavesThorn, new BlockColorCustom(Colorizers.thorn));
+        addDispatch(Block.leavesPalm, new BlockColorCustom(Colorizers.palm));
+        addDispatch(Block.mossStone, new BlockColorCustom(Colorizers.grass));
+        addDispatch(Block.mossBasalt, new BlockColorCustom(Colorizers.grass));
+        addDispatch(Block.mossLimestone, new BlockColorCustom(Colorizers.grass));
+        addDispatch(Block.mossGranite, new BlockColorCustom(Colorizers.grass));
         addDispatch(Block.wireRedstone, new BlockColorRedstoneWire());
-        addDispatch(Block.tallgrass, new BlockColorGrass());
-        addDispatch(Block.tallgrassFern, new BlockColorGrass());
+        addDispatch(Block.tallgrass, new BlockColorCustom(Colorizers.grass));
+        addDispatch(Block.tallgrassFern, new BlockColorCustom(Colorizers.grass));
     }
 
     @Override
